// SerialConfigMessage.cc

#include <stdlib.h>
#include <stddef.h>
#include <string.h>
#include <stdio.h>

#include "Message.h"
#define SerialConfigMessageDEFINE
#include "SerialConfigMessage.h"
#undef SerialConfigMessageDEFINE

DLList* SerialConfigMessage::pFreeList = 0;

int32 SerialConfigMessage:: toBuffer(char **buffer) const
{
    int32 nbytes = 0;

    nbytes = Message::toBuffer(buffer);
    nbytes += MPF::toBuffer(buffer,baud);
    nbytes += MPF::toBuffer(buffer,stopBits);
    nbytes += MPF::toBuffer(buffer,bitsPerChar);
    nbytes += MPF::toBuffer(buffer,parity);
    nbytes += MPF::toBuffer(buffer,flowControl);
    return(nbytes);
}

int32 SerialConfigMessage:: fromBuffer(const char **buffer)
{
    int32 nbytes=0;

    nbytes = Message::fromBuffer(buffer);
    nbytes += MPF::fromBuffer(buffer,&baud);
    nbytes += MPF::fromBuffer(buffer,&stopBits);
    nbytes += MPF::fromBuffer(buffer,&bitsPerChar);
    nbytes += MPF::fromBuffer(buffer,&parity);
    nbytes += MPF::fromBuffer(buffer,&flowControl);
    return(nbytes);
}

int32 SerialConfigMessage:: fromBufferSwitch(const char **buffer)
{
    int32 nbytes=0;

    nbytes = Message::fromBufferSwitch(buffer);
    nbytes += MPF::fromBufferSwitch(buffer,&baud);
    nbytes += MPF::fromBufferSwitch(buffer,&stopBits);
    nbytes += MPF::fromBufferSwitch(buffer,&bitsPerChar);
    nbytes += MPF::fromBufferSwitch(buffer,&parity);
    nbytes += MPF::fromBufferSwitch(buffer,&flowControl);
    return(nbytes);
}

void SerialConfigMessage:: print() const
{
    Message::print();
    printf("   stopBits %d\n",(int)stopBits);
    printf("       baud %d\n",baud);
    printf("bitsPerChar %d\n",(int)bitsPerChar);
    printf("     parity %d\n",(int)parity);
    printf("flowControl %d\n",(int)parity);
}

void *SerialConfigMessage:: operator new(size_t size)
{
    if(size==sizeof(SerialConfigMessage)) return MPF::allocate(&pFreeList,size);
    printf("SerialConfigMessage new size !=sizeof(SerialConfigMessage)\n");
    return(0);
}

void SerialConfigMessage:: operator delete(void *p, size_t size)
{
    if(size==sizeof(SerialConfigMessage)) {
        MPF::free(pFreeList,p,size);
        return;
    }
    printf("SerialConfigMessage delete size !=sizeof(SerialConfigMessage)\n");
}
