// messageType.cc

#include <stddef.h>
#include <string.h>
#include <stdlib.h>
#include <stddef.h>
#include <stdio.h>

#include "Message.h"
//Each message type must be included
//also a case must be added for each message type
#include "ConnectMessage.h"
#include "Char8ArrayMessage.h"
#include "Int32Message.h"
#include "Int32ArrayMessage.h"
#include "Float64Message.h"
#include "Float64ArrayMessage.h"
#include "SerialConfigMessage.h"
#include "OutOfBandMessage.h"

Message *Message::allocate(messageType type)
{
    switch(type) {
    case messageTypeConnect: return(new ConnectMessage());
    case messageTypeChar8Array: return(new Char8ArrayMessage());
    case messageTypeInt32: return(new Int32Message());
    case messageTypeInt32Array: return(new Int32ArrayMessage());
    case messageTypeFloat64: return(new Float64Message());
    case messageTypeFloat64Array: return(new Float64ArrayMessage());
    case messageTypeSerialConfig: return(new SerialConfigMessage());
    case messageTypeOutOfBand: return(new OutOfBandMessage());
    default:
	printf("Message::allocate illegal type %d\n",(int)type);
    }
    return(0);
}
